/*
	$Id: RawDataProperty.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core;

/**
	Holds information about an extended property for raw data.

	@see ExtendedProperty
	@author Nicklas
	@version 2.0
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
*/
public class RawDataProperty
	extends ExtendedProperty
{
	private final int channel;

	/**
		Create a new rawdata property.
		See the getter methods for a description of the parameters.
	*/
	RawDataProperty(String name, String title, String description, String column,
		Type type, int length, boolean nullable, Formula.AverageMethod averageMethod, int channel)
	{
		super(name, title, description, column, type, length, nullable, true, false, averageMethod, null);
		this.channel = channel;
	}

	/**
		Get the channel this property belongs to.
		@return The channel number, or zero if it doesn't belong to any particular channel
	*/
	public int getChannel()
	{
		return channel;
	}

}

