/*
  $Id: UserDefaultSettingData.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2005 Johan Enell, Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

  BASE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3
  of the License, or (at your option) any later version.

  BASE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core.data;

/**
	@author nicklas
	@see net.sf.basedb.core.UserDefaultSetting
	@see <a href="../../../../../../html/developerdoc/api/data_api.clients.html">Session and client overview</a>
	@hibernate.class table="`UserDefaultSettings`" lazy="false"
	@version 2.0
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
*/
public class UserDefaultSettingData
	extends SettingData
{
	public UserDefaultSettingData()
	{}
	
	private UserData user;
	/**
		Get the user this setting is valid for.
		@hibernate.many-to-one update="false" outer-join="false"
		@hibernate.column name="`user_id`" not-null="true" unique-key="uniquesetting"
	*/
	public UserData getUser()
	{
		return user;
	}
	public void setUser(UserData user)
	{
		this.user = user;
	}
}
