/**
	$Id:Action.java 4187 2008-03-20 11:15:25Z nicklas $

	Copyright (C) Authors contributing to this file.

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.util.extensions;

/**
	An action is an object that is added to an {@link ExtensionPoint}
	by an {@link Extension}. Each action usually results in some visual
	element, for example, a button or menu item. This is a tagging
	interface that needs to be implemented by all action objects.
	<p>
	This interface is usually subclassed for specific types of actions.
	It is the extension point that decides which action class that
	can be used in that particular extension point. See
	{@link ExtensionPoint#getActionClass()}.
	<p>
	The core doesn't define any actual action implementations, since they
	always depends on the client application. For examples,
	see the web client extensions {@link net.sf.basedb.clients.web.extensions}.

	@author nicklas
	@version 2.7
	@base.modified $Date:2008-03-20 12:15:25 +0100 (Thu, 20 Mar 2008) $
*/
public interface Action
{}
