/**
	$Id: ArrayDesignInfo.java 4480 2008-09-05 15:16:58Z jari $

	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.info;

import java.io.Serializable;


/**
 	Information class for a ArrayDesign in BASE.
 	This class holds array design information that 
 	can be handled by the Web services.
 	@see net.sf.basedb.core.ArrayDesign
  	@author Martin
 	@version 2.5
 */
public class ArrayDesignInfo 
	extends AnnotatedItemInfo
	implements Serializable
{
	private static final long serialVersionUID = 5869031159593261755L;
	private int numDbFeatures = 0;
	private int numFileFeatures = 0;
	
	/**
	 	Creates a new empty info object.
	 */
	public ArrayDesignInfo()
	{
		super();
	}
	
	/**	
	  	@param numDbFeatures The numDbFeatures to set.
	*/
	public void setNumDbFeatures(int numDbFeatures)
	{
		this.numDbFeatures = numDbFeatures;
	}

	/**	
	 	@return Returns the numDbFeatures.
	*/
	public int getNumDbFeatures()
	{
		return numDbFeatures;
	}

	/**	
	  	@param numFileFeatures The numFileFeatures to set.
	*/
	public void setNumFileFeatures(int numFileFeatures)
	{
		this.numFileFeatures = numFileFeatures;
	}

	/**	
	 	@return Returns the numFileFeatures.
	*/
	public int getNumFileFeatures()
	{
		return numFileFeatures;
	}
	
}