/**
	$Id: BioAssaySetInfo.java 4480 2008-09-05 15:16:58Z jari $

	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.info;

import java.io.Serializable;


/**
 	Information class for bioassay set in BASE
 	This class holds information that are useful when
 	working with a bioassay set over Web Services. 
 	@see net.sf.basedb.core.BioAssaySet
  	@author Martin
 	@version 2.5
 */
public class BioAssaySetInfo 
	extends BasicItemInfo
	implements NameableInfo, Serializable
{
	private static final long serialVersionUID = -1192040975292178464L;
	private String name;
	private String description;
	private int numReporters = 0;
	private int numSpots = 0;
	
	/**
	 	Creates a new empty info object
	 */
	public BioAssaySetInfo()
	{
		super();
	}

	/**	
	  	@param numReporters The numReporters to set.
	*/
	public void setNumReporters(int numReporters)
	{
		this.numReporters = numReporters;
	}

	/**	
	 	@return Returns the numReporters.
	*/
	public int getNumReporters()
	{
		return numReporters;
	}

	/**	
	  	@param numSpots The numSpots to set.
	*/
	public void setNumSpots(int numSpots)
	{
		this.numSpots = numSpots;
	}

	/**	
	 	@return Returns the numSpots.
	*/
	public int getNumSpots()
	{
		return numSpots;
	}

	public String getDescription()
	{		
		return this.description;
	}

	public String getName()
	{		
		return this.name;
	}

	public void setDescription(String description)
	{
		this.description = description;
	}

	public void setName(String name)
	{
		this.name = name;
	}
}
