/*
	$Id: TestNumberFormat.java 4480 2008-09-05 15:16:58Z jari $

	BioArray Software Environment (BASE) - http://base.thep.lu.se/
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE.

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
import net.sf.basedb.core.Type;
import net.sf.basedb.util.NumberFormatUtil;

public class TestNumberFormat
{

	static boolean ok = true;
	public static void main(String[] args)
	{
		TestUtil.checkArgs(args);
		TestUtil.begin();
		ok = test_all();
		TestUtil.stop();
	}

	static boolean test_all()
	{
		write("++Testing Number parser");

		java.text.NumberFormat dotFormat = NumberFormatUtil.getNumberFormat('.', ';');
		test_parse_number(dotFormat, "123.456", false);
		test_parse_number(dotFormat, "1.23456E2", false);
		test_parse_number(dotFormat, "12345.6e-2", false);
		test_parse_number(dotFormat, "123,456", true);
		
		java.text.NumberFormat decFormat = NumberFormatUtil.getNumberFormat(',', ';');
		test_parse_number(decFormat, "123,456", false);
		test_parse_number(decFormat, "1,23456E2", false);
		test_parse_number(decFormat, "12345,6e-2", false);
		test_parse_number(decFormat, "123.456", true);

		write("++Testing Number parser "+(ok ? "OK" : "Failed")+"\n");
		return ok;
	}

	static void write(String message)
	{
		System.out.println(message);
	}
	
	static void test_parse_number(java.text.NumberFormat format, String value, boolean shouldFail)
	{
		try
		{
			Float fValue = (Float)Type.FLOAT.parseString(value, format, false);
			if (shouldFail)
			{
				throw new Exception(value + " --> " + fValue + "f; expected failure");
			}
			if (!TestUtil.getSilent()) write(value + " --> " + fValue + "f");
		}
		catch (NumberFormatException ex)
		{
			if (!shouldFail)
			{
				ex.printStackTrace();
				ok = false;
			}
			else
			{
				if (!TestUtil.getSilent()) write(value + " failed conversion as expected: " + ex.getMessage());				
			}
		}
		catch (Throwable t)
		{
			t.printStackTrace();
			ok = false;
		}
	}

}

