/**
	$Id: BaseFileDataSource.java 4480 2008-09-05 15:16:58Z jari $

	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.ws.server;

import net.sf.basedb.core.File;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.activation.DataSource;

/** 	
  	@author Martin
  	@version 2.5
 */
public class BaseFileDataSource 
	implements DataSource
{
	private File file = null;
	private OutputStream os = null;

	/**
	 	Creates a new DataSourceObject for a file.
	  	@param file A file in Base
	 */
	public BaseFileDataSource(File file)
	{
		this.file  = file;
	}
	
	public String getContentType()
	{
		return file.getMimeType() == null ? "application/octet-stream" : file.getMimeType();
	}

	public InputStream getInputStream() 
		throws IOException
	{
		return file.getDownloadStream(0);
	}

	public String getName()
	{
		return file.getName();
	}

	public OutputStream getOutputStream() 
		throws IOException
	{			
		if (os != null) os.close();
		os = new BufferedOutputStream(file.getUploadStream(false));
		return os;
	}

}
