<%-- $Id: view_plugin.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.JobAgentSettings"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.RoleKey"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.JarClassLoader"
	import="net.sf.basedb.util.ToStringComparator"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Collections"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.TreeSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.PLUGINDEFINITION;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
	
	private static final String getShortPermissions(Item itemType, Set<Permission> granted, Set<Permission> denied)
	{
		Set<Permission> defined = itemType.getDefinedPermissions();
		StringBuilder sb = new StringBuilder();
		if (defined.contains(Permission.CREATE)) sb.append(granted.contains(Permission.CREATE) ? "C" : denied.contains(Permission.CREATE) ? "-" : "c");
		if (defined.contains(Permission.READ)) sb.append(granted.contains(Permission.READ) ? "R" :  denied.contains(Permission.READ) ? "-" : "r");
		if (defined.contains(Permission.USE)) sb.append(granted.contains(Permission.USE) ? "U" :  denied.contains(Permission.USE) ? "-" : "u");
		if (defined.contains(Permission.WRITE)) sb.append(granted.contains(Permission.WRITE) ? "W" :  denied.contains(Permission.WRITE) ? "-" : "w");
		if (defined.contains(Permission.DELETE)) sb.append(granted.contains(Permission.DELETE) ? "D" :  denied.contains(Permission.DELETE) ? "-" : "d");
		if (defined.contains(Permission.SET_OWNER)) sb.append(granted.contains(Permission.SET_OWNER) ? "O" :  denied.contains(Permission.SET_OWNER) ? "-" : "o");
		if (defined.contains(Permission.SET_PERMISSION)) sb.append(granted.contains(Permission.SET_PERMISSION) ? "P" :  denied.contains(Permission.SET_PERMISSION) ? "-" : "p");
		return sb.toString();
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	String warning = null;
	PluginDefinition plugin = PluginDefinition.getById(dc, itemId);
	final boolean internal = plugin.getJarPath() == null;
	final boolean loaded = internal || JarClassLoader.exists(plugin.getJarPath());
	final boolean usePermissions = plugin.getUsePermissions();
	final Set<GuiContext> contexts = new TreeSet<GuiContext>(new ToStringComparator<GuiContext>(false));
	contexts.addAll(plugin.getGuiContexts());
	
	final boolean usePermission = plugin.hasPermission(Permission.USE);
	final boolean writePermission = plugin.hasPermission(Permission.WRITE);
	final boolean deletePermission = plugin.hasPermission(Permission.DELETE);
	final boolean sharePermission = plugin.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = plugin.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = plugin.isRemoved();
	final boolean isUsed = isRemoved && plugin.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = plugin.isOwner();
	
	try
	{
		Plugin thePlugin = plugin.newInstance(Plugin.class, null, sc, null, null);
	}
	catch (BaseException ex)
	{
		warning = ex.getMessage();
	}
	%>
	<base:page title="<%=title%>">
	<base:head scripts="tabcontrol.js,table.js" styles="toolbar.css,headertabcontrol.css,path.css,table.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'SharePlugin', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function takeOwnership()
		{
			if (confirm('Are you sure that you want to take ownership of this item? It can\'t be undone.'))
			{
				location.replace('index.jsp?ID=<%=ID%>&cmd=TakeOwnershipOfItem&item_id=<%=itemId%>');
			}
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function unloadPlugin()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=UnloadItem&item_id=<%=itemId%>');
		}
		function newConfiguration()
		{
			Main.viewOrEditItem('<%=ID%>', 'PLUGINCONFIGURATION', 0, true, '&plugindefinition_id=<%=itemId%>');
		}
		function configurePlugin(itemId)
		{
			Main.openPopup('../../common/plugin/index.jsp?ID=<%=ID%>&cmd=ConfigurePlugin&pluginconfiguration_id='+itemId, 'ConfigurePlugin', 800, 600);
		}
		function configureAgent(agentId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true, '&jobagent_id='+agentId);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Plugins" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(plugin.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this plugin" : "You do not have permission to edit this plugin"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!plugin.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this plugin" : "You do not have permission to delete this plugin"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=plugin.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this plugin" : "You do not have permission to restore this plugin"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this plugin to other user, groups and projects" : "You do not have permission to share this plugin"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="takeOwnership()" 
				title="Take ownership&hellip;"
				visible="<%=!isOwner%>"
				tooltip="<%=setOwnerPermission ? "Take ownership of this item" : "You do not have permission to take ownership of this item"%>"
			/>
			<tbl:button
				image="add.png"
				onclick="newConfiguration()"
				title="New configuration&hellip;"
				tooltip="Create a new configuration for this plugin"
				visible="<%=sc.hasPermission(Permission.CREATE, Item.PLUGINCONFIGURATION) && 
					usePermission && plugin.supportsConfigurations()%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				onclick="unloadPlugin()"
				title="Unload"
				tooltip="<%=loaded && !internal ? "Unload the code for this plugin" : "The code for this plugin has not yet been loaded" %>"
				visible="<%=loaded && !internal%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'plugindefinition.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(plugin)%></i></div>
			<%
			if (plugin.isRemoved() || plugin.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=plugin.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<%
			if (warning != null)
			{
				%>
				<div class="error"><%=warning%></div>
				<%
			}
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(plugin.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Type</td>
				<td><%=plugin.getMainType()%></td>
			</tr>
			<tr>
				<td class="prompt">Class</td>
				<td><%=plugin.getClassName()%></td>
			</tr>
			<tr>
				<td class="prompt">Jar path</td>
				<td><%=plugin.getJarPath() == null ? "<i>- internal -</i>" : plugin.getJarPath()%></td>
			</tr>
			<tr>
				<td class="prompt">Version</td>
				<td><%=plugin.getVersionString()%></td>
			</tr>
			<tr>
				<td class="prompt">Max memory</td>
				<td><%=Values.formatBytes(plugin.getMaxMemory())%></td>
			</tr>
			<tr>
				<td class="prompt">Trusted</td>
				<td><%=plugin.isTrusted() ? "yes" : "no"%></td>
			</tr>			
			<tr>
				<td class="prompt">Allow immediate execution</td>
				<td><%=plugin.getAllowImmediateExecution() ? "yes" : "no"%></td>
			</tr>			
			<tr>
				<td class="prompt">Use internal job queue</td>
				<td><%=plugin.getUseInternalJobQueue() ? "yes" : "no"%></td>
			</tr>			
			<tr>
				<td class="prompt" valign="baseline">Items</td>
				<td><%=Values.getString(contexts, ", ", true)%></td>
			</tr>
			<tr>
				<td class="prompt">Contact</td>
				<td><%=HTML.encodeTags(plugin.getContact())%></td>
			</tr>
			<tr>
				<td class="prompt">Copyright</td>
				<td><%=HTML.encodeTags(plugin.getCopyright())%></td>
			</tr>
			<tr>
				<td class="prompt">Email</td>
				<td><%=HTML.scanForLinks(plugin.getEmail(), HTML.LINK_EMAIL, "_new")%></td>
			</tr>
			<tr>
				<td class="prompt">Url</td>
				<td><%=HTML.scanForLinks(plugin.getUrl(), HTML.LINK_URL, "_new")%></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=plugin%>" property="owner" /></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(plugin.getDescription())%></td>
			</tr>
			</table>
			<%
			ItemQuery<PluginConfiguration> configQuery = plugin.getPluginConfigurations();
			configQuery.include(Include.ALL);
			configQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<PluginConfiguration> configurations = configQuery.list(dc);
		
			if (configurations.size() == 0)
			{
				if (plugin.supportsConfigurations())
				{
					%>
					<h4>Configurations</h4>
					There are no configurations for this plugin (or, you don't have permission to view them).
					<%
				}
			}
			else
			{
				%>
				<h4 class="docked">Configurations</h4>
				<tbl:table
					id="configurations"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<tbl:columndef
					id="configure"
					title="Configure"
					show="<%=plugin.supportsConfigurations() ? "always" : "never" %>"
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (PluginConfiguration pc : configurations)
					{
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=pc.isRemoved()%>"
								/><%=Base.getLinkedName(ID, pc, false, true)%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(pc.getDescription())%></tbl:cell>
							<tbl:cell column="configure">
							<%
							if (pc.hasPermission(Permission.WRITE))
							{
								%>
								<base:icon image="runplugin.gif" 
									onclick="<%="configurePlugin(" + pc.getId() + ")"%>"
									tooltip="Configure this plugin "/>
								<%
							}
							%>
							</tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}
			%>

			<%
			ItemQuery<JobAgent> agentQuery = JobAgent.getQuery();
			agentQuery.include(Include.ALL);
			agentQuery.order(Orders.asc(Hql.property("name")));
			agentQuery.join(Hql.innerJoin("plugins", "p"));
			agentQuery.restrict(Restrictions.eq(Hql.property("p", "pluginDefinition"), Hql.entity(plugin)));
			ItemResultList<JobAgent> agents = agentQuery.list(dc);
		
			if (agents.size() == 0)
			{
				%>
				<h4>Installed on job agents</h4>
				This plugin isn't installed on any job agents (or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<h4 class="docked">Installed on job agents</h4>
				<tbl:table
					id="agents"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="server"
					title="Server"
				/>
				<tbl:columndef 
					id="info"
					title="CPU/Memory"
				/>
				<tbl:columndef
					id="jarPath"
					title="JAR path"
				/>
				<tbl:columndef
					id="maxMemory"
					title="Max memory"
				/>
				<tbl:columndef
					id="trusted"
					title="Trusted"
				/>
				<tbl:columndef
					id="priorityBoost"
					title="Priority boost"
				/>
				<tbl:columndef
					id="configure"
					title=""
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (JobAgent agent : agents)
					{
						String server = agent.getServer();
						Integer port = agent.getPort();
						JobAgentSettings settings = agent.getSettings(plugin, false);
						Long maxMemory = settings.getEffectiveMaxMemory();
						String jarPath = settings.getEffectiveJarPath();
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=agent.isRemoved()%>"
								/><%=Base.getLinkedName(ID, agent, false, true)%></tbl:cell>
							<tbl:cell column="server"><%=server == null || port == null ? "" : server + ":" + port%></tbl:cell>
							<tbl:cell column="info">
								CPU usage: <%=agent.getCpuUsage() == null ? "<i>- unknown -</i>" : agent.getCpuUsage()+"%" %><br>
								Total memory: <%=agent.getTotalMemory() == null ? "<i>- unknown -</i>" : Values.formatBytes(agent.getTotalMemory()) %><br>
								Used memory: <%=agent.getUsedMemory() == null ? "<i>- unknown -</i>" : Values.formatBytes(agent.getUsedMemory()) %>
							</tbl:cell>
							<tbl:cell column="jarPath"><%=jarPath == null ? "<i>- internal -</i>" : HTML.encodeTags(jarPath)%></tbl:cell>
							<tbl:cell column="maxMemory"><%=maxMemory == null ? "<i>- not specified -</i>" : Values.formatBytes(maxMemory)%></tbl:cell>
							<tbl:cell column="trusted"><%=settings.isEffectivelyTrusted()%></tbl:cell>
							<tbl:cell column="priorityBoost"><%=settings.getPriorityBoost()%></tbl:cell>
							<tbl:cell column="configure">
							<%
							if (agent.hasPermission(Permission.WRITE))
							{
								%>
								<base:icon image="runplugin.gif" 
									onclick="<%="configureAgent(" + agent.getId() + ")"%>"
									tooltip="Configure the settings for this plugin on the job agent "/>
								<%
							}
							%>
							</tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}			
			
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(plugin));
			ItemResultIterator<User> users = mp.getUsers().iterate(dc);
			ItemResultIterator<Group> groups = mp.getGroups().iterate(dc);
			ItemResultIterator<Project> projects = mp.getProjects().iterate(dc);
			
			if (users.hasNext() || groups.hasNext() || projects.hasNext())
			{
				%>
				<h4 class="docked">Shared to</h4>
				<tbl:table 
					id="itemsSharedTo"
					clazz="itemlist"
					columns="all"
				>
					<tbl:columndef 
						id="itemType"
						title="Item type"
					/>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="permissions"
						title="Permissions"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						while(projects.hasNext())
						{
							Project project = projects.next();
							Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
							%>			
							<tbl:row>
								<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=project.isRemoved()%>"
								/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						while(groups.hasNext())
						{
							Group group = groups.next();
							Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=group.isRemoved()%>"
								/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%	
						}
						while (users.hasNext())
						{
							User user = users.next();
							Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=user.isRemoved()%>"
								/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This plugin is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}
			%>
			<br>
			<h4>Permissions</h4>
				<table class="form" cellspacing="0">
				<tr>
					<td class="prompt">Using permissions</td>
					<td><%=usePermissions ? "yes" : "no"%></td>
				</tr>				
				</table>
				
				<div class="itemlist">
				<div class="data">
				<table border="0" cellspacing="0" cellpadding="0">
				<tr>
				<%
				Map<String, List<Item>> permissionGroups = PermissionUtil.getPermissionGroups();
				
				for (String name : permissionGroups.keySet())
				{
					%>
					<th class="columnheader" colspan="2"><b><%=name%></b></th>
					<%
				}
				%>
				</tr>
				<%
				int newItems = 0;
				int index = 0;
				int i = 0;
				do
				{
					newItems = 0;
					StringBuilder sb = new StringBuilder();
					sb.append("<tr valign=\"top\"");
					sb.append(" class=\"").append(i == 1 ? "oddrow" : "evenrow").append("\"");
					sb.append(">");
					for (String name : permissionGroups.keySet())
					{
						List<Item> items = permissionGroups.get(name);
						if (items.size() > index)
						{
							newItems++;
							Item item = items.get(index);
							int keyId = SystemItems.getRoleKeyId(item);
							RoleKey key = RoleKey.getById(dc, keyId);
							
							sb.append("<td class=\"cell\"><b>").append(key.getName()).append("</b></td>");
							sb.append("<td class=\"cell\">");
														
							if (keyId != 0)
							{								
								Set<Permission> granted = plugin.getGranted(key);
								Set<Permission> denied = plugin.getDenied(key);
								sb.append(getShortPermissions(item, granted, denied));
							}
							else
							{
								sb.append("(undefined key)");
							}
							sb.append("</td>");
						}
						else
						{
							sb.append("<td class=\"cell\" colspan=\"2\">&nbsp;</td>");
						}
					}
					if (newItems > 0)
					{
						%>
						<%=sb.toString()%>
						<%
					}
					i = 1 - i;
					index++;
				} while (newItems > 0);
				%>
				<tr class="panel">
				<td colspan="99" class="panel">
				Capital letters = Permission is always granted, Small letters = Permission is only granted if logged in user 
				has that permission<br>
				<b>C/c</b> = Create, <b>R/r</b> = Read, <b>U/u</b> = Use, 
				<b>W/w</b> = Write, <b>D/d</b> = Delete, <b>O/o</b> = Take ownership, 
				<b>P/p</b> = Change permissions
				</td>
				</tr>
				</table>
				</div>
				</div>

		</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" 
				tooltip="View annotation values" 
				visible="<%=!plugin.requiresConfiguration() && plugin.supports("net.sf.basedb.core.plugin.AnnotationSetterPlugin") %>">
				<div class="boxed">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
			</t:tab>			
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
