<%-- $Id: edit_default_membership.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.USER;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = "Default group and role membership";

	// Query to retrieve default groups
	ItemQuery<Group> groupQuery = Group.getQuery();
	groupQuery.include(Include.ALL);
	groupQuery.restrict(
		Restrictions.eq(
			Hql.property("default"), 
			Expressions.parameter("isDefault", true, Type.BOOLEAN)
		)
	);
	groupQuery.order(Orders.asc(Hql.property("name")));;

	// Query to retrieve default roles
	ItemQuery<Role> roleQuery = Role.getQuery();
	roleQuery.include(Include.ALL);
	roleQuery.restrict(
		Restrictions.eq(
			Hql.property("default"), 
			Expressions.parameter("isDefault", true, Type.BOOLEAN)
		)
	);
	roleQuery.order(Orders.asc(Hql.property("name")));;


	final boolean readGroups = sc.hasPermission(Permission.READ, Item.GROUP);
	final boolean useGroups = sc.hasPermission(Permission.USE, Item.GROUP);
	final boolean writeGroups = sc.hasPermission(Permission.WRITE, Item.GROUP);
	final boolean writeRoles = sc.hasPermission(Permission.WRITE, Item.ROLE);
	final boolean writeMembership = writeGroups && writeRoles;
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">		
		// Validate the "Membership" tab
		function validateMembership()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['user'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.addRoles.value = Link.getActionIds(1, 'R').join(',');
				frm.removeRoles.value = Link.getActionIds(-1, 'R').join(',');
				frm.addGroups.value = Link.getActionIds(1, 'G').join(',');
				frm.removeGroups.value = Link.getActionIds(-1, 'G').join(',');
				frm.submit();
			}
		}
		
		function init()
		{
			initMembership();
		}
		function initMembership()
		{
			var members = document.forms['user'].membership;
			Link.addNewSection(members, new Section('G', 'Groups'));
			<%
			ItemResultList<Group> groups = groupQuery.list(dc);
			for (Group group : groups)
			{
				%>
				Link.addNewItem(members, new Item('G', <%=group.getId()%>, '<%=HTML.javaScriptEncode(group.getName())%>'));
				<%
			}
			%>
			Link.addNewSection(members, new Section('R', 'Roles'));
			<%
			ItemResultList<Role> roles = roleQuery.list(dc);
			for (Role role : roles)
			{
				%>
				Link.addNewItem(members, new Item('R', <%=role.getId()%>, '<%=HTML.javaScriptEncode(role.getName())%>'));
				<%
			}
			%>
		}
		function addRolesOnClick()
		{
			var roles = Link.getListIds(document.forms['user'].membership, 'R');
			var url = '../roles/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addRoleCallback';
			url += '&exclude='+roles.join(',');
			Main.openPopup(url, 'AddRoles', 1000, 700);
		}
		function addRoleCallback(roleId, name)
		{
			var item = Link.getItem('R', roleId);
			if (!item) item = new Item('R', roleId, name);
			Link.addItem(document.forms['user'].membership, item);
		}
		function addGroupsOnClick()
		{
			var groups = Link.getListIds(document.forms['user'].membership, 'G');
			groups[groups.length] = <%=SystemItems.getId(Group.EVERYONE)%>;
			var url = '../groups/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addGroupCallback';
			url += '&exclude='+groups.join(',');
			Main.openPopup(url, 'AddGroups', 1000, 700);
		}
		function addGroupCallback(groupId, name)
		{
			var item = Link.getItem('G', groupId);
			if (!item) item = new Item('G', groupId, name);
			Link.addItem(document.forms['user'].membership, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['user'].membership);
		}
	
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="user" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateDefaultMembership">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*280)+"px;"%>" 
			position="bottom">

		<t:tab id="members" title="Membership" 	tooltip="Default group and role membership" 
			validate="validateMembership()" helpid="user.edit.default_membership">
			<table >
			<tr valign="top">
			<td>
				<b>Member in</b><br>
				<select name="membership" size="14" multiple <%=!writeMembership ? "disabled readonly class=\"disabled\"" : ""%> style="width: 15em;">
				</select>
				<input type="hidden" name="removeGroups" value="">
				<input type="hidden" name="addGroups" value="">
				<input type="hidden" name="removeRoles" value="">
				<input type="hidden" name="addRoles" value="">
			</td>
			<td>
				<br>
				<table width="150">
				<tr><td><base:button 
					onclick="addGroupsOnClick()" 
					title="Add&nbsp;groups&hellip;"  
					tooltip="Add groups to this user"
					disabled="<%=!writeMembership %>" 
				/></td></tr>
				<tr><td><base:button 
					onclick="addRolesOnClick()" 
					title="Add&nbsp;roles&hellip;"  
					tooltip="Add roles to this user"
					disabled="<%=!writeMembership %>" 
				/></td></tr>
				<tr><td><base:button 
					onclick="removeOnClick()" 
					title="Remove" 
					tooltip="Remove the user from the selected items"
					disabled="<%=!writeMembership%>" 
				/></td></tr>
				</table>
			</td>
			</tr>
			</table>

		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
