<%-- $Id: no_fileformat.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginType"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.Operator"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.AutoDetectingImporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final int fileId = Values.getInt(request.getParameter("file_id"));
final int pluginId = Values.getInt(request.getParameter("plugindefinition_id"));
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
final GuiContext context = new GuiContext(itemType, contextType);
final DbControl dc = sc.newDbControl();

PluginDefinition plugin = null;
if (pluginId > 0)
{
	plugin = PluginDefinition.getById(dc, pluginId);
}

final ItemContext pluginContext = sc.getCurrentContext(Item.PLUGINDEFINITION);
pluginContext.setPropertyFilter(new PropertyFilter(
	"mainType", Operator.EQ, String.valueOf(Plugin.MainType.IMPORT.getValue()), Type.INT));
pluginContext.setPropertyFilter(new PropertyFilter(
	"$ctx.itemType", Operator.EQ, String.valueOf(itemType.getValue()), Type.INT));
try
{
	File file = File.getById(dc, fileId);
	%>
	
	<base:page type="popup" title="No matching file format">
	<base:head>
		<script language="JavaScript">
		function addFileFormat()
		{
			Main.viewOrEditItem('<%=ID%>', 'PLUGINCONFIGURATION', 0, true);	
		}
		function tryAgain()
		{
			location.reload();
		}
		function useWithout()
		{
			var frm = document.forms['import'];
			frm.cmd.value = 'RunPlugin';
			Forms.createHidden(frm, 'pluginconfiguration_id', 0);
			frm.submit();
		}
		</script>
	</base:head>
	<base:body>
		<form name="import" action="index.jsp" method="get" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="AutoDetect">
		<input type="hidden" name="item_type" value="<%=itemType.name()%>">
		<input type="hidden" name="subcontext" value="<%=subContext%>">
		<input type="hidden" name="context_type" value="<%=contextType.name()%>">
		<input type="hidden" name="title" value="<%=HTML.encodeTags(request.getParameter("title"))%>">
		<input type="hidden" name="job_name" value="<%=HTML.encodeTags(request.getParameter("job_name"))%>">
		<input type="hidden" name="job_description" value="<%=HTML.encodeTags(request.getParameter("job_description"))%>">
		<input type="hidden" name="plugindefinition_id" value="<%=request.getParameter("plugindefinition_id")%>">
		<input type="hidden" name="file_id" value="<%=fileId%>">

		</form>
		
			<base:note type="info" title="No matching file format">
			<br>
			No file format that matches the file <b><%=file.getPath().toString()%></b> could be found.
			<br><br>
			</base:note>
	
		<br>
		<base:buttongroup align="center">
			<base:button onclick="addFileFormat()" 
				image="new.gif" title="Add file format&hellip;" 
				visible="<%=sc.hasPermission(Permission.CREATE, Item.PLUGINCONFIGURATION)%>"/>
			<base:button onclick="tryAgain();" image="refresh.gif" title="Try again" />
			<base:button onclick="useWithout();" image="gonext.gif" 
				title="Use w/o file format"
				visible="<%=plugin != null && !plugin.requiresConfiguration() %>" 
				tooltip="Use the plug-in without any file format" />
			<base:button onclick="window.close();" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

