<%-- $Id: logout.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	Logout from BASE.

	@param noconfirm
		If specified on the URL we display a confirmation dialogue
		otherwise we just log out and forward to the /main.jsp page

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String noconfirm = request.getParameter("noconfirm");
if (noconfirm != null)
{
	// Redirect to main login page
	String redirect = "common/close_popup.jsp?ID="+ID+"&wait=0&redirect_opener=../main.jsp?ID="+ID;;
	if (sc.isImpersonated())
	{
		SessionControl original = (SessionControl)sc.getSessionSetting("impersonate.originalSessionControl");
		boolean revert = Values.getBoolean(request.getParameter("revert"));
		if (revert)
		{
			redirect = "common/close_popup.jsp?ID="+original.getId()+"&wait=0&redirect_opener=../my_base/index.jsp?ID="+original.getId();
		}
		else
		{
			original.logout();
		}
	}
	sc.logout();
	response.sendRedirect(redirect);
	return;
}
String title = sc.isImpersonated() ? "Logout impersonated?" : "Logout?";
%>
<base:page type="popup" title="<%=title%>">
<base:head >
	<script language="JavaScript">
	function beginLogout()
	{
		Main.hide('confirm');
		Main.show('logout');
		setTimeout("document.forms['logout'].submit()", 800);
	}
	</script>
</base:head>
<base:body>
	<br>
	<form action="logout.jsp" method="get" name="logout" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="noconfirm" value="1">
	
	<div id="confirm">
		<base:note type="question" title="<%=title%>">
			Are you sure you want to logout? All unsaved data will be lost!
			<br>
		</base:note>
		<p>
		<table align="center">
		<tr>
			<td colspan="2">
			<% 
			if (sc.isImpersonated())
			{
				User originalUser = (User)sc.getSessionSetting("impersonate.originalUser");
				if (originalUser != null)
				{
					%>
					<input type="checkbox" name="revert" value="1" checked>Revert to 
					<%=HTML.encodeTags(originalUser.getName())%>
					<%
				}
			}
			%>
			</td>
		</tr>
		<tr>
			<td width="50%"><base:button onclick="beginLogout()" title="Yes" /></td>
			<td width="50%"><base:button onclick="window.close()" title="No" /></td>
		</tr>
		</table>
	</div>
	
	<div id="logout" style="display: none;">
		<base:note type="info" title="Logging out...">
		Logging out...
		</base:note>
	</div>
	
	</form>

</base:body>
</base:page>
