<%-- $Id: list.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.DynamicSpotQuery"
	import="net.sf.basedb.core.DynamicResultIterator"
	import="net.sf.basedb.core.VirtualColumn"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Dynamic"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Selects"
	import="net.sf.basedb.core.query.Aggregations"
	import="net.sf.basedb.core.query.JoinType"
	import="net.sf.basedb.core.query.SqlResult"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.ExperimentExplorer"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.REPORTER;
%>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String root = request.getContextPath();

final int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
final DbControl dc = sc.newDbControl();
DynamicResultIterator reporters = null;
try
{
	String title = null;
	final BioAssaySet bioAssaySet = BioAssaySet.getById(dc, bioAssaySetId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final RawDataType rawDataType = experiment.getRawDataType();
	
	final ExperimentExplorer explorer = ExperimentExplorer.getExplorer(bioAssaySet);
	final ItemContext cc = explorer.getAndSetReporterContext(sc, null);
	final String subContext = cc.getSubContext();

	List<TableColumn> columns = new LinkedList<TableColumn>();
	DynamicUtil.addReporterColumns(columns, dc, "", "@", "");
	
	DynamicUtil.SelectedInfo selected = DynamicUtil.getSelectedColumns(cc, columns, false);
	Map<String, Integer> selectedIndex = new HashMap<String, Integer>();
	for (int i = 0; i < selected.selectedIds.size(); ++i)
	{
		selectedIndex.put(selected.selectedIds.get(i), i+2);
	}
	
	try
	{
		DynamicSpotQuery reporterQuery = explorer.getReporterQuery(dc, selected.selectedProperties);
		reporters = reporterQuery.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	%>

	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js,newjoust.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css,newjoust.css">
	<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'reporters';
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, 'DEFAULT', viewItem, editItem, null);
		}		
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function viewReporter(index)
		{
			var url = '../view/index.jsp?ID=<%=ID%>&bioassayset_id=<%=bioAssaySetId%>';
			if (index >= 0)
			{
				url += '&cmd=SetReporterIndex&reporterIndex='+index;
			}
			location.href = url;
		}

		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'view')
			{
				viewReporter(-1);
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function newReporterList()
		{
			Table.submitToPopup(formId, 'CreateReporterList', 540, 400);
		}
	</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Experiments" href="<%="../../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&experiment_id="+experiment.getId()%>" />
			<p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&cmd=ViewItem&item_id="+bioAssaySetId%>" />
			<p:pathelement title="Explorer" />
		</p:path>
		
		<t:tabcontrol id="explorer" switch="switchTab" remember="false" active="search">
		<t:tab id="search" title="Reporter search">
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="reporters" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			>
			<tbl:hidden 
				name="bioassayset_id" 
				value="<%=String.valueOf(bioAssaySetId)%>" 
			/>
			<tbl:columndef 
				id="reporterList"
				property="reporterList"
				datatype="int"
				title="Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>			
			<%
			for (TableColumn tc : columns)
			{
				%>
				<tbl:columndef
					id="<%=tc.getId()%>"
					clazz="<%="externalId".equals(tc.getId()) ? "uniquecol" : "columnheader"%>"
					property="<%=tc.getProperty()%>"
					datatype="<%=tc.getDatatype().getStringValue()%>"
					title="<%=tc.getTitle()%>"
					sortable="<%=tc.getSortable()%>"
					filterable="<%=tc.getFilterable()%>"
					exportable="<%=tc.getExportable()%>"
					show="<%=tc.getShow()%>"
					formatter="<%=tc.getFormatter()%>"
				/>
				<%
			}
			%>
				
			<tbl:toolbar>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button
					image="add.png"
					onclick="newReporterList()"
					title="New reporter list&hellip;"
					tooltip="Create a new reporter list from matching reporters"
					visible="<%=sc.hasPermission(Permission.CREATE, Item.REPORTERLIST)%>"
				/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=reporters == null ? 0 : reporters.getTotalCount()%>" 
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="1"
					onchange="presetOnChange()"
				/>
				</tbl:columns>
				<tr>
					<tbl:header 
						clazz="icons"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
				<tbl:rows>
				
			<%
			int index = cc.getPage()*cc.getRowsPerPage();
			if (reporters != null)
			{
				while (reporters.hasNext())
				{
					SqlResult item = reporters.next();
					int itemId = item.getInt(1);
					index++;
					numListed++;
					%>
					<tbl:row>
						<tbl:header 
							clazz="icons"
							><a href="javascript:viewReporter(<%=index-1%>)"><%=index%></a></tbl:header>
						<tbl:cell column="name"><div class="link" onclick="itemOnClick(event, <%=itemId%>)" 
							title="View this item (use CTRL, ALT or SHIFT to edit)"><%=HTML.encodeTags(item.getString(selectedIndex.get("name")))%></div></tbl:cell>
						<tbl:cell column="externalId"><tbl:cellvalue value="<%=item.getString(selectedIndex.get("externalId"))%>"/></tbl:cell>
						<tbl:cell column="symbol"><tbl:cellvalue value="<%=item.getString(selectedIndex.get("symbol"))%>"/></tbl:cell>
						<tbl:cell column="description"><tbl:cellvalue value="<%=item.getString(selectedIndex.get("description"))%>"/></tbl:cell>
						<tbl:cell column="lastUpdate"><tbl:cellvalue value="<%=item.getObject(selectedIndex.get("lastUpdate"))%>"/></tbl:cell>
						<%
						List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
						if (reporterProperties != null)
						{
							for (ExtendedProperty ep : reporterProperties)
							{
								String name = ep.getName();
								%>
								<tbl:cell column="<%=name%>"><tbl:cellvalue value="<%=item.getObject(selectedIndex.get(name))%>" /></tbl:cell>
							<%
							}
						}
						%>
					</tbl:row>
					<%
				}
			}
			%>
			</tbl:rows>
			</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=reporters == null || reporters.getTotalCount() == 0 ? "No reporters were found" : "No reporters on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=reporters == null ? 0 : reporters.getTotalCount()%>"
					locked="true"
				/>
				<%
			}
			%>
			</tbl:table>
		</t:tab>

		<t:tab id="view" title="Reporter view" />
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (reporters != null) reporters.close();
	if (dc != null) dc.close();
}

%>
