<%-- $Id: index.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	This file is part of BASE.

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ExperimentExplorer"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%
final int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";

final String viewPage = "view.jsp?ID="+ID+"&bioassayset_id="+bioAssaySetId;

String forward = null;
String redirect = null;
String message = null;

DbControl dc = null;
try
{
	dc = sc.newDbControl();
	BioAssaySet bioAssaySet = BioAssaySet.getById(dc, bioAssaySetId);
	ExperimentExplorer explorer = ExperimentExplorer.getExplorer(bioAssaySet);
	if (cmd == null || "Explore".equals(cmd))
	{
		redirect = viewPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		ItemContext cc = explorer.getAndSetSpotContext(sc, pageContext);
		redirect = viewPage;
	}
	else if ("SetReporterIndex".equals(cmd))
	{
		explorer.setReporterIndex(Values.getInt(request.getParameter("reporterIndex")));
		redirect = viewPage;
	}
	else if ("SetSpotIndex".equals(cmd))
	{
		explorer.setPositionIndex(Values.getInt(request.getParameter("spotIndex")));
		redirect = viewPage;
	}
	else if ("SetAnnotationType".equals(cmd))
	{
		explorer.setAnnotationTypeId(Values.getInt(request.getParameter("annotationtype_id")));
		
		// If an annotation type is selected the annotation column must be visible as the first column
		ItemContext cc = explorer.getAndSetSpotContext(sc, null);
		String columns = cc.getSetting("columns");
		if (explorer.getAnnotationTypeId() != 0)
		{
			if (!columns.contains("annotation")) columns = "annotation," + columns;
		}
		else
		{
			columns.replace("annotation", "");
		}
		cc.setSetting("columns", columns);
		redirect = viewPage;
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}
if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}

%>




